<template>
<div :class="{'menu-section': true}" v-if="sections[currentPage]">
    <div class="container-fluid menu-container">
        <div class='row justify-content-center align-items-center'>
            <template v-for="(section, i) in sections[currentPage]" >
                <div @click.prevent="scrollTo(currentPage, section.link)" :id="section.link + (section.link ? '-nav' : '')" :class="{'col col-auto menu-list': true, 'disabled': section.position.top == section.position.down }" :key="section.name">
                    <a :href="'#' + section.link">{{section.name}}</a><span class="soon" v-if="section.position.top == section.position.down">SOON</span>
                </div>
                <div class="col col-auto menu-arrow" v-if="i < sections[currentPage].length - 1" :key="i">
                    <caret-next/>
                </div>
            </template>
        </div>
    </div>
</div>
</template>

<script>
import { mapGetters } from 'vuex'
import CaretNext from "~/assets/images/icons/arrows-chevron-forward.svg?inline";
import smoothscroll from 'smoothscroll-polyfill';

export default {
    components: {
        CaretNext
    },
    data() {
        return {
            sections: {
                "/technology": [{name: 'How does it work?', link: this.$links('scrollTo.technology')[0], position: {top: 0, down: 4000} }, {name: 'How does it compare?', link: this.$links('scrollTo.technology')[1], position: {top: 4000, down: 4885}}, {name: 'Has it been audited?', link: this.$links('scrollTo.technology')[2], position: {top: 4885, down: 5370}}, {name: 'How active is it?', link: this.$links('scrollTo.technology')[3], position: {top: 5370, down: 6600}}],
                "/economics": [ {name: "What does it do?", link: 'top', position: {top: 0, down: 8215} }, {name: "How many will exist?", link: 'exist', position: {top: 8215, down: 9081}}, {name: "What influences it?", link: 'community', position: {top: 9081, down: 9600}}, {name: "Where do I get it?", link: 'geckotable', position: {top: 9600, down: 10783}}, {name: "Where do I store it?", link: 'top', position: {top: 0, down: 0}}, {name: "How do I use it?", link: 'apy', position: {top: 10783, down: 12000}} ],
                
                "/rune": [ {name: "What does it do?", link: this.$links('scrollTo.rune')[0], position: {top: 0, down: 7800} }, {name: "How many will exist?", link: this.$links('scrollTo.rune')[1], position: {top: 7800, down: 8500}}, {name: "What influences it?", link: this.$links('scrollTo.rune')[2], position: {top: 8500, down: 9300}}, {name: "Where do I get it?", link: this.$links('scrollTo.rune')[3], position: {top: 9300, down: 10280}}, {name: "Where do I store it?", link: '', position: {top: 0, down: 0}}, {name: "How do I use it?", link:  this.$links('scrollTo.rune')[4], position: {top: 10280, down: 12000}} ],
                
                "/community": [ {name: "What does it do?", link: 'top', position: {top: 0, down: 8215} }, {name: "How many will exist?", link: 'exist', position: {top: 8215, down: 9081}}, {name: "What influences it?", link: 'community', position: {top: 9120, down: 9990}}, {name: "Where do I get it?", link: 'geckotable', position: {top: 9990, down: 10962}}, {name: "Where do I store it?", link: 'top', position: {top: 0, down: 0}}, {name: "How do I use it?", link: 'apy', position: {top: 10962, down: 12000}} ],
                "/roles": [ {name: "What does it do?", link: 'top', position: {top: 0, down: 8215} }, {name: "How many will exist?", link: 'exist', position: {top: 8215, down: 9120}}, {name: "What influences it?", link: 'community', position: {top: 9120, down: 9990}}, {name: "Where do I get it?", link: 'geckotable', position: {top: 9990, down: 10962}}, {name: "Where do I store it?", link: 'top', position: {top: 0, down: 0}}, {name: "How do I use it?", link: 'apy', position: {top: 10962, down: 12000}} ],
                "/ecosystem": [ {name: "What does it do?", link: 'top', position: {top: 0, down: 8215} }, {name: "How many will exist?", link: 'exist', position: {top: 8215, down: 9120}}, {name: "What influences it?", link: 'community', position: {top: 9120, down: 9990}}, {name: "Where do I get it?", link: 'geckotable', position: {top: 9990, down: 10962}}, {name: "Where do I store it?", link: 'top', position: {top: 0, down: 0}}, {name: "How do I use it?", link: 'apy', position: {top: 10962, down: 12000}} ],
                "/decentralized": [ {name: "What does it do?", link: 'what-does-it-do', position: {top: 0, down: 8215} }, {name: "How many will exist?", link: 'how-many-will-exist', position: {top: 8215, down: 9120}}, {name: "What influences it?", link: 'what-influences-it', position: {top: 9120, down: 9990}}, {name: "Where do I get it?", link: 'what-influences-it', position: {top: 9990, down: 10962}}, {name: "Where do I store it?", link: 'top', position: {top: 0, down: 0}}, {name: "How do I use it?", link: 'what-influences-it', position: {top: 10962, down: 12000}} ],
            }
        }
    },
    mounted() {
        this.changeActiveState();
    },
    computed: {
        currentPage() {
            return this.$route.path
        },
        ...mapGetters(['scrollY'])
    },
    updated: function () {
        this.$nextTick(function () {
            // Code that will run only after the
            // entire view has been re-rendered
            console.log('rerender')
            this.changeActiveState();
        })
    },
    methods: {
        changeActiveState() {
            if (typeof window !== 'undefined') {
                // We are in the browser
                setTimeout(() => {

                    var section = document.querySelectorAll(".anchor-point");
                    var sections = [];
                    var i = 0;
                    let ii = 0;

                    console.log(section)

                    Array.prototype.forEach.call(section, function(e) {
                        sections.push({offset: e.offsetTop, num: ii, id: e.id});
                        ii++;
                    });

                    window.onscroll = function() {
                        var scrollPosition = document.documentElement.scrollTop || document.body.scrollTop;

                        
                        if(sections.length === 0 ) return
                        let section = sections.reduce((p, c) => {
                            return c.offset <= scrollPosition + document.querySelector('header').offsetHeight + 1 && p.offset < c.offset ? c : p
                        });

                        if(document.querySelector(`.menu-list#${section.id}-nav`) && !document.querySelector('.menu-list.active')) {
                            console.log('triggred once')
                            document.querySelector(`.menu-list#${section.id}-nav`).classList.add('active');
                                // location.hash = '#' + section.id;
                                history.pushState(null, null, '#' + section.id);

                        }
                        else if (document.querySelector(`.menu-list#${section.id}-nav`) && document.querySelector('.menu-list.active').getAttribute('id') && '#' + section.id !== location.hash) {
                            console.log('triggred')
                            if(document.querySelector(`.menu-list.active`))
                                document.querySelector(`.menu-list.active`).classList.remove('active')
                            document.querySelector(`.menu-list#${section.id}-nav`).classList.add('active');
                                // location.hash = '#' + section.id;
                                history.pushState(null, null, '#' + section.id);
                        }
                    };
                }, 200)
            }
        },
        scrollTo(currentPage, selector) {
            if(!selector)
                return
            if (window && document) { 
                smoothscroll.polyfill();
                // document.getElementById(selector).scrollIntoView({ 
                //     behavior: 'smooth' 
                // });
                let offset = document.getElementById(selector).offsetTop;
                window.scroll({
                    top: offset, 
                    left: 0, 
                    behavior: 'smooth'
                });
            }
            
            // this.$router.push({ path: currentPage, hash: selector})
        }
    }
}
</script>

<style lang="scss" scoped>
    .menu-section {
        width: 100%;
        background-color: $thor-divider-border-color;
        box-shadow: 0 1px 0px black;
        height: 2.8125rem ;
        transition: all 0.3s ease-out;

        &.empty {
            height: 0;
        }
    }

    .menu-container {
        font-family: Roboto;
        margin: 0rem auto;
    }

    .menu-arrow {
        padding: 0rem 0.9375rem ;

        svg {
            width: 0.6875rem ;
            height: 0.6875rem ;
            fill: black;
        }
    }

    .menu-list {
        display: inline-block;
        padding: 0.75rem 0;
        cursor: pointer;
        transition: all 0.2s;
        font-size: 0.875rem ;
        border-bottom: 0.0625rem solid transparent;
        transition: all 0.2s ease-out;


        a:hover {
            color: #20CAB8;
           transition: all 0.2s ease-in;
        }

        a {
            text-decoration: none;
            color: white;
        }

        &.active {
            border-bottom: 0.0625rem solid #20CAB8;
            
            a {
                color: #20CAB8;
            }
        }

        &.disabled {
            position: relative;
            pointer-events: none;
            a {
                color: #5b666d;
                font-weight: 500;
            }
        }

        .soon {
            position: absolute;
            font-weight: 300;
            font-size: 0.6em;
            top: 0.25rem ;
            right: 0;
            color: $thor-yellow-color;
        }
    }

</style>